/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	ForceSuspendLearnBusinessAction
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.engine;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import jp.co.ntt.lms.lo.scorm.util.Debug;
import jp.co.ntt.lms.xms.framework.XmsBusinessAction;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;
import jp.co.ntt.lms.xms.framework.XmsSystemException;

/**
 *	ForceSuspendLearnBusinessAction クラス<br>
 *	起動済みの教材を強制中断するクラス<br>
 */
public class ForceSuspendLearnBusinessAction extends XmsBusinessAction {
	/**
	 * デフォルトコンストラクタ
	 */
	public ForceSuspendLearnBusinessAction() {}

	/**
	 * 初期化処理
	 *
	 * @param	xmsRequest	リクエストオブジェクト
	 */
	protected void initProcessRequest(XmsRequest xmsRequest) throws XmsException {}

	/**
	 * 起動済み教材の強制中断処理<br>
	 * applicationからエンジンを取り出し、中断処理を行う
	 *
	 * @param	xmsRequest	リクエストオブジェクト
	 * @param	xmsResponse	レスポンスオブジェクト
	 */
	protected void processRequest(XmsRequest xmsRequest, XmsResponse xmsResponse) throws XmsException {
		try {
			HttpServletRequest request = xmsRequest.getRequest();
			HttpSession session = request.getSession();
			ServletContext application = session.getServletContext();

			// 起動パラメータを作成する
			ExecuteParameters executeParameters = new ExecuteParameters();

			executeParameters.initialize(xmsRequest);

			// エンジンのapplicationキー名を作成する
			String engineKeyName =
				"SCORM." + executeParameters.getUserID() + "." + executeParameters.getLOID() + ".ENGINE";

			// エンジンをapplicationから取得する
			Engine engine = (Engine)application.getAttribute(engineKeyName);

			// 正常に取得できた場合
			if (engine != null) {
				// 中断情報をXMSⅡへ送信する
				Exception error = null;

				synchronized (engine) {
					try {
						// 中断処理を行う
						engine.discontinue("SUSPEND", true);
					}
					catch (Exception ex) {
						Debug.write(ex);

						error = ex;
					}

					// applicationからエンジンを削除する
					application.removeAttribute(engineKeyName);
				}

				// 中断処理中に例外が発生した場合
				if (error != null) {
					LearningLogSendErrorBusinessBean llsebb = new LearningLogSendErrorBusinessBean(executeParameters);
					llsebb.setException(error);

					xmsResponse.setBusinessBean(llsebb);
					xmsResponse.setBusinessStatus("LearningLogSendError");
				}
			}
		}
		catch (Exception ex) {
			throw new XmsSystemException(ex);
		}
	}
}
